-- This file was automatically generated.
{-# LANGUAGE ScopedTypeVariables, PatternSynonyms #-}
module Graphics.GL.Raw.Extension.NV.FramebufferMultisampleCoverage (
  -- * Extension Support
    gl_NV_framebuffer_multisample_coverage

  -- * GL_NV_framebuffer_multisample_coverage
  , glRenderbufferStorageMultisampleCoverageNV
  , pattern GL_MAX_MULTISAMPLE_COVERAGE_MODES_NV
  , pattern GL_MULTISAMPLE_COVERAGE_MODES_NV
  , pattern GL_RENDERBUFFER_COLOR_SAMPLES_NV
  , pattern GL_RENDERBUFFER_COVERAGE_SAMPLES_NV
) where

import Control.Monad.IO.Class
import Data.Set
import Foreign.Ptr
import Graphics.GL.Raw.Internal.FFI
import Graphics.GL.Raw.Internal.Proc
import Graphics.GL.Raw.Types
import System.IO.Unsafe

-- | Checks that the <https://cvs.khronos.org/svn/repos/ogl/trunk/doc/registry/public/specs/NV/framebuffer_multisample_coverage.txt GL_NV_framebuffer_multisample_coverage> extension is available.

gl_NV_framebuffer_multisample_coverage :: Bool
gl_NV_framebuffer_multisample_coverage = member "GL_NV_framebuffer_multisample_coverage" extensions
{-# NOINLINE gl_NV_framebuffer_multisample_coverage #-}

-- | Usage: @'glRenderbufferStorageMultisampleCoverageNV' target coverageSamples colorSamples internalformat width height@
--
-- The parameter @target@ is a @RenderbufferTarget@.
--
-- The parameter @internalformat@ is a @PixelInternalFormat@.


glRenderbufferStorageMultisampleCoverageNV :: MonadIO m => GLenum -> GLsizei -> GLsizei -> GLenum -> GLsizei -> GLsizei -> m ()
glRenderbufferStorageMultisampleCoverageNV = ffienumsizeisizeienumsizeisizeiIOV glRenderbufferStorageMultisampleCoverageNVFunPtr

glRenderbufferStorageMultisampleCoverageNVFunPtr :: FunPtr (GLenum -> GLsizei -> GLsizei -> GLenum -> GLsizei -> GLsizei -> IO ())
glRenderbufferStorageMultisampleCoverageNVFunPtr = unsafePerformIO (getProcAddress "glRenderbufferStorageMultisampleCoverageNV")

{-# NOINLINE glRenderbufferStorageMultisampleCoverageNVFunPtr #-}

pattern GL_MAX_MULTISAMPLE_COVERAGE_MODES_NV = 0x8E11

pattern GL_MULTISAMPLE_COVERAGE_MODES_NV = 0x8E12

pattern GL_RENDERBUFFER_COLOR_SAMPLES_NV = 0x8E10

pattern GL_RENDERBUFFER_COVERAGE_SAMPLES_NV = 0x8CAB